How to Show Pie Percentage in Tooltip in Angular Chart

11 Aug 20264 minutes to read

By using the tooltipRender event, you can show the percentage value for each point of pie series in tooltip.

To show the percentage value in pie tooltip, follow the given step:

Step 1:

By using the tooltipRender event, you can access the args.point.y and args.series.sumOfPoints values from the event arguments. You can use these values to calculate the percentage value for each point of pie series. To display the percentage value in tooltip, use the args.content property.

import { ChartModule, ChartAllModule, AccumulationChartAllModule } from '@syncfusion/ej2-angular-charts'
import { AccumulationChartModule } from '@syncfusion/ej2-angular-charts'
import { PieSeriesService, AccumulationTooltipService, AccumulationDataLabelService } from '@syncfusion/ej2-angular-charts'
import {
    LineSeriesService, DateTimeService, DataLabelService, StackingColumnSeriesService, CategoryService,
    StepAreaSeriesService, SplineSeriesService, ScrollBarService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
    SelectionService, ScatterSeriesService, ZoomService, ColumnSeriesService, AreaSeriesService, RangeAreaSeriesService
} from '@syncfusion/ej2-angular-charts'


import { Component, OnInit } from '@angular/core';
import { IAccTooltipRenderEventArgs } from '@syncfusion/ej2-angular-charts';
@Component({
imports: [
         ChartModule, ChartAllModule, AccumulationChartAllModule, AccumulationChartModule
    ],

providers: [LineSeriesService, DateTimeService, ColumnSeriesService, DataLabelService, ZoomService, StackingColumnSeriesService, CategoryService,
        StepAreaSeriesService, SplineSeriesService, ChartAnnotationService, LegendService, TooltipService, StripLineService,
        PieSeriesService, AccumulationTooltipService, ScrollBarService, AccumulationDataLabelService, SelectionService, ScatterSeriesService,
        AreaSeriesService, RangeAreaSeriesService ],
standalone: true,
    selector: 'app-container',
    template: `<ejs-accumulationchart id="chart-container" [tooltip]='tooltip' [title]='title' (tooltipRender)='tooltipRender($event)'>
        <e-accumulation-series-collection>
            <e-accumulation-series [dataSource]='piedata' xName='x' yName='y' [dataLabel]='datalabel' radius="70%"></e-accumulation-series>
        </e-accumulation-series-collection>
    </ejs-accumulationchart>`
})
export class AppComponent implements OnInit {
    public piedata?: Object[];
    public datalabel?: Object;
    public tooltip?: Object;
    public title?: String;
    public tooltipRender(args: IAccTooltipRenderEventArgs): void {
           let value  = args.point.y / args.series.sumOfPoints * 100;
           args["text"] = args.point.x + ' : ' + Math.ceil(value) + '' + '%';
        };
    ngOnInit(): void {
        this.datalabel = { visible: true };
        this.tooltip = {enable: true};
        this.title = 'Mobile Browser Statistics';
        this.piedata = [
                    { 'x': 'Chrome', y: 37 }, { 'x': 'UC Browser', y: 17 },
                    { 'x': 'iPhone', y: 19 }, { 'x': 'Others', y: 4 }, { 'x': 'Opera', y: 11 }
                ];
    }

}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to show percentage in pie tooltip in React Chart

26 Aug 20267 minutes to read

To show each slice’s percentage share in a pie tooltip, hook the tooltipRender callback on the chart and assign the formatted string to args.text. The callback fires once per hovered slice.

You also need to register PieSeries and AccumulationTooltip inside <Inject services={[...]} />, and enable tooltip support on the chart by setting the tooltip’s enable property to true. Without enabling tooltips, the tooltipRender callback will not be triggered.

Calculate and assign the percentage

The tooltipRender callback receives an args object. Two fields are useful here:

Field Meaning
args.point.y The numeric value of the hovered slice.
args.series.sumOfPoints The sum of all slice values in the series.

Divide args.point.y by args.series.sumOfPoints and multiply by 100 to get the slice’s percentage share. Assign the formatted string to args.text; that string is what the tooltip renders:

const tooltipRender = (args) => {
    const value = (args.point.y / args.series.sumOfPoints) * 100;
    args.text = `${args.point.x} ${Math.ceil(value)}%`;
};

Bind the callback on the <AccumulationChartComponent>:

<AccumulationChartComponent id='charts' tooltip={{ enable: true }} tooltipRender={tooltipRender}>

The complete example is shown below:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective, Inject, AccumulationDataLabel, AccumulationTooltip, PieSeries } from '@syncfusion/ej2-react-charts';
import { data } from './datasource';
function App() {
    const datalabel = { visible: true, position: 'Inside', name: 'text' };
    const tooltip = { enable: true };
    const tooltipRender = (args) => {
        let value = args.point.y / args.series.sumOfPoints * 100;
        args.text = args.point.x + '' + Math.ceil(value) + '' + '%';
    };
    return <AccumulationChartComponent id='charts' tooltip={tooltip} title='Mobile Browser Statistics' tooltipRender={tooltipRender}>
      <Inject services={[AccumulationTooltip, PieSeries, AccumulationDataLabel]}/>
      <AccumulationSeriesCollectionDirective>
        <AccumulationSeriesDirective dataSource={data} xName='x' yName='y' radius='70%' dataLabel={datalabel}>
        </AccumulationSeriesDirective>
      </AccumulationSeriesCollectionDirective>
    </AccumulationChartComponent>;
}
;
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
import * as React from "react";
import * as ReactDOM from "react-dom";
import { AccumulationChartComponent, AccumulationSeriesCollectionDirective, AccumulationSeriesDirective,IAccTooltipRenderEventArgs, Inject, AccumulationDataLabel, AccumulationTooltip, PieSeries,AccumulationDataLabelSettingsModel,TooltipSettingsModel } from '@syncfusion/ej2-react-charts';
import{ EmitType } from '@syncfusion/ej2-base';
import { data } from './datasource';
function App() {
  const datalabel: AccumulationDataLabelSettingsModel = { visible: true, position: 'Inside', name: 'text' };
  const tooltip: TooltipSettingsModel = { enable: true };
  const tooltipRender: EmitType<IAccTooltipRenderEventArgs> = (args: IAccTooltipRenderEventArgs): void => {
    let value: any = args.point.y / args.series.sumOfPoints * 100;
    args.text = args.point.x + '' + Math.ceil(value) + '' + '%';
  };

  return <AccumulationChartComponent id='charts' tooltip={tooltip} title='Mobile Browser Statistics'
      tooltipRender={tooltipRender}>
      <Inject services={[AccumulationTooltip, PieSeries, AccumulationDataLabel]} />
      <AccumulationSeriesCollectionDirective>
        <AccumulationSeriesDirective dataSource={data} xName='x' yName='y' radius='70%' dataLabel={datalabel}>
        </AccumulationSeriesDirective>
      </AccumulationSeriesCollectionDirective>
    </AccumulationChartComponent>

};
export default App;
ReactDOM.render(<App />, document.getElementById("charts"));
export let data = [
    { 'x': 'Chrome',     y: 37, text: '37' }, 
    { 'x': 'UC Browser', y: 17, text: '17' },
    { 'x': 'iPhone',     y: 19, text: '19' }, 
    { 'x': 'Others',     y: 4,  text: '4'  },
    { 'x': 'Opera',      y: 11, text: '11' }
];
export let data: Object[] = [
    { 'x': 'Chrome',     y: 37, text: '37' }, 
    { 'x': 'UC Browser', y: 17, text: '17' },
    { 'x': 'iPhone',     y: 19, text: '19' }, 
    { 'x': 'Others',     y: 4,  text: '4'  },
    { 'x': 'Opera',      y: 11, text: '11' }
];

Troubleshooting

  • “The tooltip shows the raw value instead of a percentage” — the tooltipRender callback is not bound on <AccumulationChartComponent>, or tooltip support has not been enabled on the chart. Both are required for the callback to fire.
  • “The tooltip shows NaN% for every slice” — args.series.sumOfPoints is 0. Either populate the data source with non-zero values or guard the division.
  • “The slices do not add up to exactly 100%” — the example uses Math.ceil, which rounds up. Switch to Math.round if you need exact totals.

See also